OpenVDB 5.1.0

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Protected Attributes | List of all members
ValueAccessor< TreeType, IsSafe, 3, tbb::null_mutex > Class Template Reference

Template specialization of the ValueAccessor with no mutex and three cache levels. More...

`#include <ValueAccessor.h>`

Inherits ValueAccessor3< TreeType, IsSafe >.

## Public Types
using | TreeType = TreeType
using | ValueType = typename TreeType::ValueType
using | RootNodeT = typename TreeType::RootNodeType
using | LeafNodeT = typename TreeType::LeafNodeType
using | BaseT = ValueAccessorBase< TreeType, IsSafe >
using | InvTreeT = typename RootNodeT::NodeChainType
using | NodeT0 = typename boost::mpl::at< InvTreeT, boost::mpl::int_< L0 > >::type
using | NodeT1 = typename boost::mpl::at< InvTreeT, boost::mpl::int_< L1 > >::type
using | NodeT2 = typename boost::mpl::at< InvTreeT, boost::mpl::int_< L2 > >::type

## Public Member Functions
| ValueAccessor (TreeType &tree)
| ValueAccessor (const ValueAccessor &)=default
ValueAccessor & | operator= (const ValueAccessor &)=default
| ~ValueAccessor () override=default
bool | isCached (const Coord &xyz) const
const ValueType & | getValue (const Coord &xyz) const
| Return the value of the voxel at the given coordinates. More...
bool | isValueOn (const Coord &xyz) const
| Return the active state of the voxel at the given coordinates. More...
bool | probeValue (const Coord &xyz, ValueType &value) const
| Return the active state of the voxel as well as its value. More...
int | getValueDepth (const Coord &xyz) const
bool | isVoxel (const Coord &xyz) const
void | setValueOn (const Coord &xyz)
| Mark the voxel at the given coordinates as active without changing its value. More...
void | setValueOnly (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinate but preserves its active state. More...
void | setValueOff (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as inactive. More...
void | setValueOff (const Coord &xyz)
| Mark the voxel at the given coordinates as inactive without changing its value. More...
void | modifyValue (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active. More...
void | modifyValueAndActiveState (const Coord &xyz, const ModifyOp &op)
| Apply a functor to the voxel at the given coordinates. More...
void | setActiveState (const Coord &xyz, bool on=true)
| Set the active state of the voxel at the given coordinates without changing its value. More...
NodeT * | getNode ()
| Return the cached node of type NodeType. [Mainly for internal use]. More...
void | insertNode (const Coord &xyz, NodeT &node)
void | eraseNode ()
void | addLeaf (LeafNodeT *leaf)
| Add the specified leaf to this tree, possibly creating a child branch in the process. If the leaf node already exists, replace it. More...
void | addTile (Index level, const Coord &xyz, const ValueType &value, bool state)
| Add a tile at the specified tree level that contains voxel (x, y, z), possibly deleting existing nodes or creating new nodes in the process. More...
LeafNodeT * | touchLeaf (const Coord &xyz)
NodeT * | probeNode (const Coord &xyz)
LeafNodeT * | probeLeaf (const Coord &xyz)
const LeafNodeT * | probeLeaf (const Coord &xyz) const
const NodeT * | probeConstNode (const Coord &xyz) const
const LeafNodeT * | probeConstLeaf (const Coord &xyz) const
void | clear () override
| Remove all the cached nodes and invalidate the corresponding hash-keys. More...
TreeType * | getTree () const
| Return a pointer to the tree associated with this accessor. More...
TreeType & | tree () const
| Return a reference to the tree associated with this accessor. More...
void | setValue (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as active. More...
void | setValueOn (const Coord &xyz, const ValueType &value)
| Set the value of the voxel at the given coordinates and mark the voxel as active. More...

## Static Public Member Functions
static Index | numCacheLevels ()
| Return the number of cache levels employed by this ValueAccessor. More...
static bool | isSafe ()
| Return true if this accessor is safe, i.e. registered by the tree from which it is constructed. Un-registered accessors can in rare cases be faster because it avoids the (small) overhead of registration, but they are unsafe if the tree is modified. So unless you're an expert it is highly recommended to set IsSafe = true (which is the default). More...

## Static Public Attributes
static const bool | IsConstTree = std::is_const<TreeType>::value

## Protected Attributes
TreeType * | mTree

## Detailed Description

### template<typename TreeType, bool IsSafe>
class openvdb::v5_1::tree::ValueAccessor< TreeType, IsSafe, 3, tbb::null_mutex >

Template specialization of the ValueAccessor with no mutex and three cache levels.

## Member Typedef Documentation

## ◆ BaseT

using BaseT = ValueAccessorBase<TreeType, IsSafe>
| inherited

## ◆ InvTreeT

using InvTreeT = typename RootNodeT::NodeChainType
| inherited

## ◆ LeafNodeT

using LeafNodeT = typename TreeType::LeafNodeType
| inherited

## ◆ NodeT0

using NodeT0 = typename boost::mpl::at<InvTreeT, boost::mpl::int_<L0> >::type
| inherited

## ◆ NodeT1

using NodeT1 = typename boost::mpl::at<InvTreeT, boost::mpl::int_<L1> >::type
| inherited

## ◆ NodeT2

using NodeT2 = typename boost::mpl::at<InvTreeT, boost::mpl::int_<L2> >::type
| inherited

## ◆ RootNodeT

using RootNodeT = typename TreeType::RootNodeType
| inherited

## ◆ TreeType

using TreeType = TreeType
| inherited

## ◆ ValueType

using ValueType = typename TreeType::ValueType
| inherited

## Constructor & Destructor Documentation

## ◆ ValueAccessor() [1/2]

ValueAccessor | ( | TreeType & | tree | ) |
| inline

## ◆ ValueAccessor() [2/2]

ValueAccessor | ( | const ValueAccessor< TreeType, IsSafe, 3, tbb::null_mutex > & |  | ) |
| default

## ◆ ~ValueAccessor()

~ValueAccessor | ( |  | ) |
| override default

## Member Function Documentation

## ◆ addLeaf()

void addLeaf | ( | LeafNodeT * | leaf | ) |
| inline inherited

Add the specified leaf to this tree, possibly creating a child branch in the process. If the leaf node already exists, replace it.

## ◆ addTile()

void addTile | ( | Index | level,
|  | const Coord & | xyz,
|  | const ValueType & | value,
|  | bool | state
| ) |  |
| inline inherited

Add a tile at the specified tree level that contains voxel (x, y, z), possibly deleting existing nodes or creating new nodes in the process.

## ◆ clear()

void clear | ( |  | ) |
| inline override virtual inherited

Remove all the cached nodes and invalidate the corresponding hash-keys.

Implements ValueAccessorBase< TreeType, IsSafe >.

## ◆ eraseNode()

void eraseNode | ( |  | ) |
| inline inherited

If a node of the given type exists in the cache, remove it, so that isCached(xyz) returns `false` for any voxel (x, y, z) contained in that node. [Mainly for internal use]

## ◆ getNode()

NodeT* getNode | ( |  | ) |
| inline inherited

Return the cached node of type NodeType. [Mainly for internal use].

## ◆ getTree()

TreeType* getTree | ( |  | ) | const
| inline inherited

Return a pointer to the tree associated with this accessor.

The pointer will be null only if the tree from which this accessor was constructed was subsequently deleted (which generally leaves the accessor in an unsafe state).

## ◆ getValue()

const ValueType& getValue | ( | const Coord & | xyz | ) | const
| inline inherited

Return the value of the voxel at the given coordinates.

## ◆ getValueDepth()

int getValueDepth | ( | const Coord & | xyz | ) | const
| inline inherited

Return the tree depth (0 = root) at which the value of voxel (x, y, z) resides, or -1 if (x, y, z) isn't explicitly represented in the tree (i.e., if it is implicitly a background voxel).

## ◆ insertNode()

void insertNode | ( | const Coord & | xyz,
|  | NodeT & | node
| ) |  |
| inline inherited

Cache the given node, which should lie along the path from the root node to the node containing voxel (x, y, z). [Mainly for internal use]

## ◆ isCached()

bool isCached | ( | const Coord & | xyz | ) | const
| inline inherited

Return `true` if any of the nodes along the path to the given voxel have been cached.

## ◆ isSafe()

static bool isSafe | ( |  | ) |
| inline static inherited

Return true if this accessor is safe, i.e. registered by the tree from which it is constructed. Un-registered accessors can in rare cases be faster because it avoids the (small) overhead of registration, but they are unsafe if the tree is modified. So unless you're an expert it is highly recommended to set IsSafe = true (which is the default).

## ◆ isValueOn()

bool isValueOn | ( | const Coord & | xyz | ) | const
| inline inherited

Return the active state of the voxel at the given coordinates.

## ◆ isVoxel()

bool isVoxel | ( | const Coord & | xyz | ) | const
| inline inherited

Return `true` if the value of voxel (x, y, z) resides at the leaf level of the tree, i.e., if it is not a tile value.

## ◆ modifyValue()

void modifyValue | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline inherited

Apply a functor to the value of the voxel at the given coordinates and mark the voxel as active.

See Tree::modifyValue() for details.

## ◆ modifyValueAndActiveState()

void modifyValueAndActiveState | ( | const Coord & | xyz,
|  | const ModifyOp & | op
| ) |  |
| inline inherited

Apply a functor to the voxel at the given coordinates.

See Tree::modifyValueAndActiveState() for details.

## ◆ numCacheLevels()

static Index numCacheLevels | ( |  | ) |
| inline static inherited

Return the number of cache levels employed by this ValueAccessor.

## ◆ operator=()

ValueAccessor& operator= | ( | const ValueAccessor< TreeType, IsSafe, 3, tbb::null_mutex > & |  | ) |
| default

## ◆ probeConstLeaf()

const LeafNodeT* probeConstLeaf | ( | const Coord & | xyz | ) | const
| inline inherited

Returns
  a const pointer to the leaf node that contains voxel (x, y, z) and if it doesn't exist, return `nullptr`.

## ◆ probeConstNode()

const NodeT* probeConstNode | ( | const Coord & | xyz | ) | const
| inline inherited

Returns
  a const pointer to the node of the specified type that contains voxel (x, y, z) and if it doesn't exist, return `nullptr`.

## ◆ probeLeaf() [1/2]

LeafNodeT* probeLeaf | ( | const Coord & | xyz | ) |
| inline inherited

Returns
  a pointer to the leaf node that contains voxel (x, y, z) and if it doesn't exist, return `nullptr`.

## ◆ probeLeaf() [2/2]

const LeafNodeT* probeLeaf | ( | const Coord & | xyz | ) | const
| inline inherited

## ◆ probeNode()

NodeT* probeNode | ( | const Coord & | xyz | ) |
| inline inherited

Returns
  a pointer to the node of the specified type that contains voxel (x, y, z) and if it doesn't exist, return `nullptr`.

## ◆ probeValue()

bool probeValue | ( | const Coord & | xyz,
|  | ValueType & | value
| ) |  | const
| inline inherited

Return the active state of the voxel as well as its value.

## ◆ setActiveState()

void setActiveState | ( | const Coord & | xyz,
|  | bool | on = `true`
| ) |  |
| inline inherited

Set the active state of the voxel at the given coordinates without changing its value.

## ◆ setValue()

void setValue | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline inherited

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValueOff() [1/2]

void setValueOff | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline inherited

Set the value of the voxel at the given coordinates and mark the voxel as inactive.

## ◆ setValueOff() [2/2]

void setValueOff | ( | const Coord & | xyz | ) |
| inline inherited

Mark the voxel at the given coordinates as inactive without changing its value.

## ◆ setValueOn() [1/2]

void setValueOn | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline inherited

Set the value of the voxel at the given coordinates and mark the voxel as active.

## ◆ setValueOn() [2/2]

void setValueOn | ( | const Coord & | xyz | ) |
| inline inherited

Mark the voxel at the given coordinates as active without changing its value.

## ◆ setValueOnly()

void setValueOnly | ( | const Coord & | xyz,
|  | const ValueType & | value
| ) |  |
| inline inherited

Set the value of the voxel at the given coordinate but preserves its active state.

## ◆ touchLeaf()

LeafNodeT* touchLeaf | ( | const Coord & | xyz | ) |
| inline inherited

Returns
  the leaf node that contains voxel (x, y, z) and if it doesn't exist, create it, but preserve the values and active states of all voxels.

Use this method to preallocate a static tree topology over which to safely perform multithreaded processing.

## ◆ tree()

TreeType& tree | ( |  | ) | const
| inline inherited

Return a reference to the tree associated with this accessor.

## Member Data Documentation

## ◆ IsConstTree

const bool IsConstTree = std::is_const<TreeType>::value
| static inherited

## ◆ mTree

TreeType* mTree
| protected inherited

The documentation for this class was generated from the following file:

- ValueAccessor.h